# File: SCAuditorium.py
"""\
unknown

"""
# Copyright (c) 2005 by Lukas Zdych
# Generator: ArchGenXML Version 1.4 devel 4 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Lukas Zdych <lukas.zdych@gmail.com>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *




from Products.SCAuditorium.config import *
##code-section module-header #fill in your manual code here
##/code-section module-header

schema= Schema((
    StringField('title',
        widget=StringWidget(
            label="Title",
            description="Enter title for this Auditorium.",
            label_msgid='SCAuditorium_label_title',
            description_msgid='SCAuditorium_help_title',
            i18n_domain='SCAuditorium',
        ),
        required=True,
        searchable=True,
    ),
    
    TextField('description',
        widget=TextAreaWidget(
            label="Description",
            description="Enter short description for this Auditorium.",
            label_msgid='SCAuditorium_label_description',
            description_msgid='SCAuditorium_help_description',
            i18n_domain='SCAuditorium',
        ),
        required=False,
        searchable=True,
    ),
    
    ImageField('auditorium_icon',
        widget=ImageWidget(
            label="Auditorium icon",
            description="Upload image for auditorim title icon.",
            label_msgid='SCAuditorium_label_auditorium_icon',
            description_msgid='SCAuditorium_help_auditorium_icon',
            i18n_domain='SCAuditorium',
        ),
        storage=AttributeStorage(),
        original_size=(64,64),
        sizes={'icon':(16, 16), 'thumb':(64,64)},
    ),
    
    StringField('portraits_size',
        default=VOC_PORTRAIT_SIZES[1],
        widget=SelectionWidget(
            label="Portraits size",
            description="Select which size of users's portraits should be used when displaying Comments.",
            label_msgid='SCAuditorium_label_portraits_size',
            description_msgid='SCAuditorium_help_portraits_size',
            i18n_domain='SCAuditorium',
        ),
        required=True,
        vocabulary=VOC_PORTRAIT_SIZES,
    ),
    
    BooleanField('show_emails',
        widget=BooleanWidget(
            label="Show emails",
            description="Check this option to display email addresses of comment authors.",
            label_msgid='SCAuditorium_label_show_emails',
            description_msgid='SCAuditorium_help_show_emails',
            i18n_domain='SCAuditorium',
        ),
        accessor="showEmails",
    ),
    
    StringField('date_formats',
        default=1,
        widget=SelectionWidget(
            label="Date formats",
            description="Select which format will be used to displaying dates of comments creation.",
            label_msgid='SCAuditorium_label_date_formats',
            description_msgid='SCAuditorium_help_date_formats',
            i18n_domain='SCAuditorium',
        ),
        accessor="dateFormats",
        vocabulary=VOC_DATE_FORMATS,
    ),
    
    IntegerField('def_page_size',
        default=20,
        widget=IntegerWidget(
            label="Default page size",
            description="Enter integer value for default items count on one page of Auditorium ( value can be temporarelly changed by user during Auditorium browsing).",
            label_msgid='SCAuditorium_label_def_page_size',
            description_msgid='SCAuditorium_help_def_page_size',
            i18n_domain='SCAuditorium',
        ),
        accessor="getPageSize",
    ),
    
    LinesField('banned_words',
        widget=LinesWidget(
            label="Banned words",
            description="Enter list of words which will be replaced by 'cover string' in comment's body. Define each word on it's own line please.",
            label_msgid='SCAuditorium_label_banned_words',
            description_msgid='SCAuditorium_help_banned_words',
            i18n_domain='SCAuditorium',
        ),
        accessor="bannedWords",
    ),
    
    StringField('cover_string',
        default="*****",
        widget=StringWidget(
            label="Cover string",
            description="Enter string which will be used to replace bannded words founded in comment's bodyf words which will be replaced by 'cover string' in comment's body.",
            label_msgid='SCAuditorium_label_cover_string',
            description_msgid='SCAuditorium_help_cover_string',
            i18n_domain='SCAuditorium',
        ),
        accessor="coverString",
    ),
    
    LinesField('allowed_html_tags',
        widget=LinesWidget(
            label="Allowed HTML tags",
            description="Enter list of HTML tags which can be used in Comment's body. Define each tag on it's own line please (not implemented yet).",
            label_msgid='SCAuditorium_label_allowed_html_tags',
            description_msgid='SCAuditorium_help_allowed_html_tags',
            i18n_domain='SCAuditorium',
        ),
    ),
    
    IntegerField('max_item_length',
        default=256,
        widget=IntegerWidget(
            label="Max. Comment body length",
            description="Enter integer value for maximal length of Comment's body.",
            label_msgid='SCAuditorium_label_max_item_length',
            description_msgid='SCAuditorium_help_max_item_length',
            i18n_domain='SCAuditorium',
        ),
        accessor="getLimitedTextMaxlength",
    ),
    
    BooleanField('moderated',
        widget=BooleanWidget(
            label="Moderated Auditorium",
            description="Check this option to make Auditorium moderated (not implemented yet).",
            label_msgid='SCAuditorium_label_moderated',
            description_msgid='SCAuditorium_help_moderated',
            i18n_domain='SCAuditorium',
        ),
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class SCAuditorium(BaseBTreeFolder):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseBTreeFolder,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'Auditorium'

    meta_type    = 'SCAuditorium' 
    portal_type  = 'SCAuditorium' 
    allowed_content_types      = ['SCAuditoriumItem'] 
    filter_content_types       = 1
    global_allow               = 1
    allow_discussion           = 0
    #content_icon               = 'SCAuditorium.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "Auditorium"
    typeDescMsgId              = 'description_edit_scauditorium'

    actions =  (


       {'action':      "string:$object_url/scauditorium_view",
        'category':    "object",
        'id':          'view',
        'name':        'View',
        'permissions': (VIEW_PERMISSION,),
        'condition'  : 'python:1'
       },
        

       {'action':      "string:$object_url/scauditorium_moderate",
        'category':    "object",
        'id':          'moderate',
        'name':        'Moderate',
        'permissions': (EDIT_PERMISSION,),
        'condition'  : 'python:1'
       },
        

    )

    schema = BaseFolderSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declareProtected(VIEW_PERMISSION, 'getAuditorium')
    def getAuditorium(self):
        """
        Helper method for searching comments.
        """
        
        return self



registerType(SCAuditorium,PROJECTNAME)
# end of class SCAuditorium

##code-section module-footer #fill in your manual code here
##/code-section module-footer



